<?xml version="1.0" encoding="utf-8"?>
<collection>
<spec_type>
  <kind>
      normal
  </kind>

  <data_type>
      char*
  </data_type>

  <value>
      malloc(config_stat.st_size)
  </value>

  <init_code>
      read(config_fd, $0, config_stat.st_size);
  </init_code>

  <associating>
      <interfaces>
          snd_input_buffer_open
      </interfaces>
    
      <links>
          param2
      </links>
  </associating>
</spec_type>

<spec_type>
  <kind>
      env
  </kind>

  <global_code>
      #include <sys/stat.h>
  </global_code>

  <init_code>
      int config_fd = open(TEST_DATA_PATH("alsa.conf"), O_RDWR);
      struct stat config_stat;
      fstat(config_fd, &config_stat);
  </init_code>

  <final_code>
      close(config_fd);
  </final_code>

  <associating>
      <interfaces>
          snd_input_buffer_open
      </interfaces>
  </associating>
</spec_type>

<spec_type>
  <kind>
      normal
  </kind>

  <data_type>
      int
  </data_type>

  <value>
      config_stat.st_size
  </value>

  <associating>
      <interfaces>
          snd_input_buffer_open
      </interfaces>
    
      <links>
          param3
      </links>
  </associating>
</spec_type>

<spec_type>
  <kind>
      normal
  </kind>

  <data_type>
      snd_ctl_elem_id_t*
  </data_type>

  <final_code>
      snd_ctl_elem_id_set_name($0, "name");
  </final_code>

  <associating>
      <interfaces>
          snd_ctl_elem_id_malloc
      </interfaces>
    
      <links>
          param1
      </links>
  </associating>
</spec_type>

<spec_type>
  <kind>
      normal
  </kind>

  <data_type>
      snd_ctl_elem_info_t*
  </data_type>

  <final_code>
      snd_ctl_elem_info_set_id($0, $(snd_ctl_elem_id_t*));
  </final_code>

  <associating>
      <interfaces>
          snd_ctl_elem_info_malloc
      </interfaces>
    
      <links>
          param1
      </links>
  </associating>
</spec_type>

<spec_type>
  <kind>
      normal
  </kind>

  <data_type>
      snd_ctl_elem_value_t*
  </data_type>

  <final_code>
      snd_ctl_elem_value_set_id($0, $(snd_ctl_elem_id_t*));
  </final_code>

  <associating>
      <interfaces>
          snd_ctl_elem_value_malloc
      </interfaces>
    
      <links>
          param1
      </links>
  </associating>
</spec_type>

<spec_type>
  <kind>
      normal
  </kind>

  <data_type>
      snd_hctl_t*
  </data_type>

  <final_code>
      snd_hctl_load($0);
  </final_code>

  <associating>
      <interfaces>
          snd_hctl_open
      </interfaces>
    
      <links>
          param1
      </links>
  </associating>
</spec_type>

<spec_type>
  <kind>
      normal
  </kind>

  <data_type>
      snd_hctl_t*
  </data_type>

  <final_code>
      snd_hwdep_dsp_load($0, $(snd_hwdep_dsp_image_t*));
  </final_code>

  <associating>
      <interfaces>
          snd_hwdep_open
      </interfaces>
    
      <links>
          param1
      </links>
  </associating>
</spec_type>

<spec_type>
  <kind>
      normal
  </kind>

  <data_type>
      int
  </data_type>

  <value>
      SND_HWDEP_OPEN_DUPLEX
  </value>

  <associating>
      <interfaces>
          snd_hwdep_open
      </interfaces>
    
      <links>
          param3
      </links>
  </associating>
</spec_type>

<spec_type>
  <kind>
      normal
  </kind>

  <data_type>
      snd_mixer_t*
  </data_type>

  <final_code>
      snd_mixer_attach($0, "hw:0");
      snd_mixer_selem_register($0, NULL, NULL);
      snd_mixer_load($0);
  </final_code>

  <associating>
      <interfaces>
          snd_mixer_open
      </interfaces>
    
      <links>
          param1
      </links>
  </associating>
</spec_type>

<spec_type>
  <kind>
      normal
  </kind>

  <data_type>
      snd_async_handler_t*
  </data_type>

  <init_code>
      snd_async_add_handler(&$0, $(int), $(snd_async_callback_t), $(void*));
  </init_code>

  <associating>
      <interfaces>
          snd_async_del_handler
          snd_async_handler_get_callback_private
      </interfaces>
    
      <links>
          param1
      </links>
  </associating>
</spec_type>

<spec_type>
  <kind>
      normal
  </kind>

  <data_type>
      snd_async_handler_t*
  </data_type>

  <init_code>
      snd_async_add_pcm_handler(&$0, $(snd_pcm_t*), $(snd_async_callback_t), $(void*));
  </init_code>

  <associating>
      <interfaces>
          snd_async_handler_get_pcm
      </interfaces>
    
      <links>
          param1
      </links>
  </associating>
</spec_type>

<spec_type>
  <kind>
      normal
  </kind>

  <data_type>
      snd_async_handler_t*
  </data_type>

  <init_code>
      snd_async_add_ctl_handler(&$0, $(snd_ctl_t*), $(snd_async_callback_t), $(void*));
  </init_code>

  <associating>
      <interfaces>
          snd_async_handler_get_ctl
      </interfaces>
    
      <links>
          param1
      </links>
  </associating>
</spec_type>

<spec_type>
  <kind>
      normal
  </kind>

  <data_type>
      int
  </data_type>

  <value>
      SND_SEQ_OPEN_DUPLEX
  </value>

  <associating>
      <interfaces>
          snd_seq_open
      </interfaces>
    
      <links>
          param3
      </links>
  </associating>
</spec_type>

<spec_type>
  <kind>
      normal
  </kind>

  <data_type>
      char const*
  </data_type>

  <value>
      "default"
  </value>

  <associating>
      <interfaces>
          snd_seq_open
      </interfaces>
    
      <links>
          param2
      </links>
  </associating>
</spec_type>

<spec_type>
  <kind>
      normal
  </kind>

  <data_type>
      int
  </data_type>

  <value>
      SND_SEQ_EVENT_STOP
  </value>

  <associating>
      <interfaces>
          snd_seq_control_queue
      </interfaces>
    
      <links>
          param3
      </links>
  </associating>
</spec_type>

<spec_type>
  <kind>
      normal
  </kind>

  <data_type>
      int
  </data_type>

  <value>
      snd_seq_alloc_queue($1)
  </value>

  <associating>
      <interfaces>
          snd_seq_control_queue
      </interfaces>
    
      <links>
          param2
      </links>
  </associating>
</spec_type>

<spec_type>
  <kind>
      normal
  </kind>

  <data_type>
      char const*
  </data_type>

  <init_code>
      char timername[64];
      sprintf(timername, "hw:CLASS=%i, SCLASS=%i, CARD=%i, DEV=%i, SUBDEV=%i", SND_TIMER_CLASS_GLOBAL, SND_TIMER_CLASS_NONE, 0, SND_TIMER_GLOBAL_SYSTEM, 0);
  </init_code>

  <value>
      timername
  </value>

  <associating>
      <interfaces>
          snd_timer_open
      </interfaces>
    
      <links>
          param2
      </links>
  </associating>
</spec_type>

<spec_type>
  <kind>
      normal
  </kind>

  <data_type>
      int
  </data_type>

  <value>
      SND_TIMER_OPEN_NONBLOCK
  </value>

  <associating>
      <interfaces>
          snd_timer_open
      </interfaces>
    
      <links>
          param3
      </links>
  </associating>
</spec_type>

<spec_type>
  <kind>
      normal
  </kind>

  <data_type>
      char const*
  </data_type>

  <value>
      "virtual"
  </value>

  <associating>
      <interfaces>
          snd_rawmidi_open
      </interfaces>
    
      <links>
          param3
      </links>
  </associating>
</spec_type>

<spec_type>
  <kind>
      normal
  </kind>

  <data_type>
      snd_rawmidi_t*
  </data_type>

  <init_code>
      snd_rawmidi_open(0, &$0, "virtual", SND_RAWMIDI_NONBLOCK);
  </init_code>

  <value>
      0
  </value>

  <associating>
      <interfaces>
          snd_rawmidi_write
      </interfaces>
    
      <links>
          param1
      </links>
  </associating>
</spec_type>

<spec_type>
  <kind>
      normal
  </kind>

  <data_type>
      snd_timer_status_t*
  </data_type>

  <init_code>
      snd_timer_status_malloc(&$0);
  </init_code>

  <associating>
      <interfaces>
          snd_timer_status
      </interfaces>
    
      <links>
          param2
      </links>
  </associating>
</spec_type>

<spec_type>
  <kind>
      normal
  </kind>

  <data_type>
      int
  </data_type>

  <value>
      SND_RAWMIDI_NONBLOCK
  </value>

  <associating>
      <interfaces>
          snd_rawmidi_open
      </interfaces>
    
      <links>
          param4
      </links>
  </associating>
</spec_type>

<spec_type>
  <kind>
      normal
  </kind>

  <data_type>
      int
  </data_type>

  <value>
      SND_PCM_NONBLOCK
  </value>

  <associating>
      <interfaces>
          snd_pcm_open
      </interfaces>
    
      <links>
          param4
      </links>
  </associating>
</spec_type>

<spec_type>
  <kind>
      normal
  </kind>

  <data_type>
      snd_pcm_t*
  </data_type>

  <value>
      $1
  </value>

  <associating>
      <interfaces>
          snd_pcm_link
      </interfaces>
    
      <links>
          param2
      </links>
  </associating>
</spec_type>

<spec_type>
  <kind>
      normal
  </kind>

  <data_type>
      snd_config_t*
  </data_type>

  <value>
      snd_config
  </value>

  <associating>
      <interfaces>
          snd_pcm_open_lconf
      </interfaces>
    
      <links>
          param5
      </links>
  </associating>
</spec_type>

<spec_type>
  <kind>
      env
  </kind>

  <init_code>
      snd_config_update();
  </init_code>

  <associating>
      <interfaces>
          snd_pcm_open_lconf
      </interfaces>
  </associating>
</spec_type>
         
<spec_type>
  <kind>
      normal
  </kind>

  <data_type>
      snd_ctl_elem_info_t*
  </data_type>

  <init_code>
      snd_hctl_elem_t *elem = snd_hctl_first_elem($(snd_hctl_t*));
      snd_ctl_elem_id_t* e_id = 0;
    
      snd_ctl_elem_id_malloc(&e_id);
      snd_hctl_elem_get_id(elem, e_id);
    
      snd_ctl_elem_info_malloc(&$0);
      snd_ctl_elem_info_set_id($0, e_id);
      snd_hctl_elem_info(elem, $0);
  </init_code>

  <value>
      0
  </value>

  <associating>
      <interfaces>
          snd_ctl_elem_info_get_items
      </interfaces>
    
      <links>
          param1
      </links>
  </associating>
</spec_type>

</collection>