<?xml version="1.0" encoding="utf-8"?>

<spec_type>
  <kind>
      common_env
  </kind>

  <init_code>
      g_thread_init(NULL);
      g_type_init();
  </init_code>

  <libs>
      libgobject-2.0.so
      libgthread-2.0.so
  </libs>

  <global_code>
      #include <glib-object.h>
      #include <glib.h>
  </global_code>
</spec_type>

<spec_type>
  <kind>
      common_param
  </kind>

  <data_type>
      GInitiable*
  </data_type>

  <value>
      g_initable_new()
  </value>

  <global_code>
      #include <gio/gio.h>
  </global_code>
</spec_type>

<spec_type>
  <kind>
      normal
  </kind>

  <data_type>
      int
  </data_type>

  <value>
      sizeof(struct sockaddr_in)
  </value>

  <associating>
      <interfaces>
          soup_address_new_from_sockaddr
      </interfaces>
    
      <links>
          param2
      </links>
  </associating>
</spec_type>

<spec_type>
  <kind>
      normal
  </kind>

  <data_type>
      char const*
  </data_type>

  <value>
      "port"
  </value>

  <associating>
      <interfaces>
          soup_server_new
      </interfaces>
    
      <links>
          param1
      </links>
  </associating>
</spec_type>

<spec_type>
  <kind>
      normal
  </kind>

  <data_type>
      int
  </data_type>

  <value>
      SOUP_ADDRESS_ANY_PORT
  </value>

  <associating>
      <interfaces>
          soup_server_new
      </interfaces>
    
      <links>
          param2
      </links>
  </associating>
</spec_type>

<spec_type>
  <kind>
      normal
  </kind>

  <data_type>
      char const*
  </data_type>

  <value>
      "realm"
  </value>

  <associating>
      <interfaces>
          soup_auth_domain_basic_new
      </interfaces>
    
      <links>
          param1
      </links>
  </associating>
</spec_type>

<spec_type>
  <kind>
      normal
  </kind>

  <data_type>
      char const*
  </data_type>

  <value>
      "simple-proxy"
  </value>

  <associating>
      <interfaces>
          soup_auth_domain_basic_new
      </interfaces>
    
      <links>
          param2
      </links>
  </associating>
</spec_type>

<spec_type>
  <kind>
      normal
  </kind>

  <data_type>
      char const*
  </data_type>

  <value>
      0
  </value>

  <associating>
      <interfaces>
          soup_socket_new
          soup_session_sync_new_with_options
          soup_session_async_new_with_options
          soup_auth_domain_digest_new
      </interfaces>
    
      <links>
          param1
      </links>
  </associating>
</spec_type>

<spec_type>
  <kind>
      normal
  </kind>

  <data_type>
      int
  </data_type>

  <value>
      soup_address_get_type()
  </value>

  <associating>
      <interfaces>
          soup_value_hash_new_with_vals
      </interfaces>
    
      <links>
          param2
      </links>
  </associating>
  <associating>
      <interfaces>
          soup_value_hash_insert_vals
      </interfaces>
    
      <links>
          param3
      </links>
  </associating>
</spec_type>

<spec_type>
  <kind>
      normal
  </kind>

  <data_type>
      char const*
  </data_type>

  <value>
      "<methodCall><methodName>examples.getStateName</methodName></methodCall>"
  </value>

  <associating>
      <interfaces>
          soup_xmlrpc_extract_method_call
          soup_xmlrpc_extract_method_response
          soup_xmlrpc_parse_method_call
          soup_xmlrpc_parse_method_response
      </interfaces>
    
      <links>
          param1
      </links>
  </associating>
</spec_type>

<spec_type>
  <kind>
      normal
  </kind>

  <data_type>
      int
  </data_type>

  <value>
      strlen($1)
  </value>

  <associating>
      <interfaces>
          soup_xmlrpc_extract_method_call
          soup_xmlrpc_extract_method_response
          soup_xmlrpc_parse_method_call
          soup_xmlrpc_parse_method_response
      </interfaces>
    
      <links>
          param2
      </links>
  </associating>
</spec_type>

<spec_type>
  <kind>
      common_param
  </kind>

  <data_type>
      GValueArray*
  </data_type>

  <init_code>
      init_GValueArray($0);
  </init_code>

  <global_code>
      void init_GValueArray(GValueArray* array)
      {
          GValue value = {0};
          g_value_init (&value, G_TYPE_STRING);
          g_value_array_append(array, &value);
          g_value_array_append(array, &value);
      }
  </global_code>
</spec_type>